<!doctype html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

  <title>reveal.js</title>

  <link rel="stylesheet" href="css/reveal.css">
  <link rel="stylesheet" href="css/theme/black.css">

  <!-- Theme used for syntax highlighting of code -->
  <link rel="stylesheet" href="lib/css/zenburn.css">

  <!-- Printing and PDF exports -->
  <script>
    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
    document.getElementsByTagName('head')[0].appendChild(link);
  </script>
</head>

<body>
  <div class="reveal">
    <div class="slides">
      <section>
        <h1>Intro to Rust</h1>

        <h3>What is Rust? Where is Rust? Why is Rust?</h3>
        <!--<small>with apologies to Gamora and Drax</small>
          ok let's not hit people over the head with it-->
        <p><small>Created by Joshua Nelson with <a href="https://github.com/hakimel/reveal.js/">reveal.js</a></small>
      </section>
      <section>
        <section>
          <h2>Where did Rust come from?</h2>
          <p>In many ways, a reaction to other languages</p>
          <a href="https://tim.dreamwidth.org/1784423.html"><q>no ideas newer than 10 years old</q></a>
          <ul>
            <li>Memory safety &rarr; <a href="https://doc.rust-lang.org/book/ch04-02-references-and-borrowing.html">borrow checker</a></li>
            <li>Thread safety &rarr; <a href="https://doc.rust-lang.org/nomicon/send-and-sync.html"><code>Send</code> and <code>Sync</code></a></li>
            <li>Stability without stagnation <small>(or, why <a href="https://www.youtube.com/watch?t=1057&v=rHIkrotSwcc&feature=youtu.be"><code>unique_ptr</code> has overhead</a>)</small>
            &rarr; source-level backwards compatibility</li>
          </ul>
        </section>
        <section>
          <h3>Memory safety</h3>
          <ul>
            <li>Null pointers</li>
            <li>Out-of-bounds accesses</li>
            <li>Use after free (including iterator invalidation)</li>
            <li>Integer overflow</li>
          </ul>
          <p>See my <a href="https://acm.cse.sc.edu/events/2020-04-23/">previous talk</a> for details</p>
        </section>
        <section>
          <h3>Thread safety</h3>
          <p>In C especially, most libraries not designed with threads in mind</p>
          <p>Example: <code>errno</code> is very broken in the presence of threads (<code>__errno_location</code>)</p>
          <p><small>It turns out all my slides are actually just <a href="https://fasterthanli.me/articles/a-dynamic-linker-murder-mystery">Amos blog posts repackaged</a></small></p>
        </section>
        <section>
          <h3>Backwards compatibility</h3>
          <h4>Or, why is unique_ptr slow?</h4>
          <ul>
            <li>C++ has the worst of both worlds: unstable ABI that can't be changed<small><a href="https://acm.cse.sc.edu/events/2020-09-10/">What is an ABI?</a></small></li>
            <li>Three languages in one</li>
            <li>Python: <q>The standard library is where modules go to die</q></li>
          </ul>
        </section>
      </section>
      <section>
        <h2>What is Rust?</h2>
        <!-- This is absolutely a selling pitch btw I make no claim not to be a fanboy -->
        <img src="img/rust-landing-page.png">
        <ul>
          <li>Reliable</li>
          <li>Efficient</li>
          <li>Polished</li>
        </ul>
      </section>
      <section>
        <section>
          <h3>Reliable</h3>
          <!-- 2 columns, using https://stackoverflow.com/a/37701064/7669110 and max-width -->
          <div style="text-align: left; float: left; max-width: 50%;">
            <ul>
              <li>Type-safety with <code>Option</code> and <code>Result</code></li>
              <li>Memory and thread safety with <code>unsafe</code> and borrow-checking</li>
              <li>Extremes: <a href="http://cliffle.com/blog/rust-typestate/">Type state</a></li>
              <!-- <li>Orphan rules (not covered in this talk because they're painful)</li> -->
            </ul>
            <hr>
            <q><a href="https://gankra.github.io/blah/linear-rust/#must-be-used-at-least-once">Rust users want static verification</a></q>
          </div>

          <div style="text-align: right; float: right; max-width: 50%;">
            <img height=500 src="https://leftoversalad.com/c/015_programmingpeople/PPrust.png">
            <small>image credit: <a href="https://leftoversalad.com/c/015_programmingpeople/">leftoversalad comics</a></small>
          </div>
        </section>
        <section>
          <h3>Type-safety</h3>
          <p>Option is a <em>library</em> features, not a language feature</p>
          <p>Combinators!</p>
          <pre><code>let other: Vec&lt;String&gt; = response
  .get("warnings")
  .and_then(|j| j.get("other"))
  .and_then(|j| j.as_array())
  .map(|x| x.iter().flat_map(|j| j.as_str()).map(Into::into).collect())
  .unwrap_or_else(Vec::new);</code></pre>
  <p>^ real code taken from <code>cargo</code><p>
          <q><a href="https://users.rust-lang.org/t/twir-quote-of-the-week/328/884">Rust was created by a secret cabal of Haskell developers to teach programmers monads</a></q>
        </section>
        <section>
          <h3>Type-safety</h3>
          <p><a href="https://doc.rust-lang.org/std/result/enum.Result.html"><code>Result</code></a> means errors can't be ignored</p>
          <p>
            Let's pick on Go <br>(taken from <a href="https://blog.golang.org/error-handling-and-go">official error handling page</a>):
            <a href="https://play.golang.org/p/hIcAxF6AZV_e">playground</a>
          </p>
          <pre><code>f, err := os.Open("filename.ext")
if err != nil {
    log.Fatal(err)
}
// do something with the open *File f</code></pre>
          <p>Not unique to Go - C, C++, <a href="https://github.com/algesten/ureq/issues/128#issuecomment-739568229">most HTTP libraries</a> have the same issue</p>
          <p>Vaguely adapted from <a href="https://fasterthanli.me/articles/abstracting-away-correctness"><q>Abstracting Away Correctness</q></a></p>
        </section>
        <section>
          <h3>Memory Safe</h3>
          <ul>
            <li>"Safe" has a very specific meaning: memory safety and thread safety</li>
            <li>See <a href="https://acm.cse.sc.edu/events/2020-04-23/">previous talk</a> for details</li>
            <li>Speed of C/C++ without segfaults</li>
            <li><a href="https://doc.rust-lang.org/book/ch04-01-what-is-ownership.html#ways-variables-and-data-interact-move">Borrow checker</a>: shared XOR mutable</li>
            <li><code>unsafe</code> gives you an escape hatch</li>
          </ul>
        </section>
      </section>
      <section>
        <h2>Efficiency</h2>
        <img src="img/llvm go brr.png">
        <p>Compile speed vs. runtime</p>
        <!-- cranelift if we have time but probably not -->
      </section>
      <section>
        <h2>Polished</h2>
        <ul>
          <li>Standard build tool, Cargo, that doesn't suck (looking at you CMake, pip)</li>
          <li>1st-class documentation (Rustdoc, <a href="https://docs.rs/">docs.rs</a>)</li>
          <li>Standard formatter (Rustfmt) <ul><li>disclaimer, I hate rustfmt, it's the worst formatter except for all the others</li></ul></li>
          <li><a href="https://en.wikipedia.org/wiki/Orthogonality_(programming)">Orthogonal</a> language features (orthogonal &rarr; independent, complement each other)
            <ul>
              <li>Traits and operator overloading</li>
              <li><code>cfg</code> and unit tests</li>
            </ul>
          </li>
        </ul>
      </section>
      <section>
        <h2>Who is using Rust?</h2>
        <p>Lots of people!</p>
        <ul>
          <li>Amazon</li>
          <li>Microsoft</li>
          <li>Firefox</li>
          <li>Dropbox</li>
          <li>1Password</li>
          <li>npm</li>
          <li>System76</li>
          <li>... <a href="https://www.rust-lang.org/production/users">more</a></li>
        </ul>
      </section>
      <section>
        <section>
          <h2>The real reason to use rust</h2>
        </section>
        <section>
          <h2>The real reason to use rust</h2>
          <h3>Ferris emojis</h3>
          <img src="img/ferrisEmojis.png">
        </section>
      </section>
      <section>
        <h2>Where can I learn more?</h2>
        <ul>
          <li><a href="https://www.rust-lang.org/learn">Documentation</a></li>
          <li><a href="https://www.rust-lang.org/community">Users</a></li>
          <li><a href="https://fasterthanli.me/tags/rust">Blogs</a></li>
          <li>Read code written in Rust (ripgrep, cargo-deadlinks, etc.)</li>
        </ul>
      </section>
    </div>
  </div>

  <script src="lib/js/head.min.js"></script>
  <script src="js/reveal.js"></script>

  <script>
    // More info about config & dependencies:
    // - https://github.com/hakimel/reveal.js#configuration
    // - https://github.com/hakimel/reveal.js#dependencies
    Reveal.initialize({
      // Push each slide change to the browser history. Implies `hash: true`
      history: true,
      dependencies: [
        { src: 'plugin/zoom-js/zoom.js', async: true },
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/highlight/highlight.js', async: true, callback: function () { hljs.initHighlightingOnLoad(); } }
      ]
    });
  </script>
</body>

</html>
